# Импортируем необходимое
import pygame
import random
import os

# Вводоим необходимые переменные
WIDTH = 500
HEIGHT = 800
FPS = 60
x_ = 200
y_ = 10
time2 = 0
time3 = 0
time22 = 0
ime = 120
time11 = 0
active_lov = 0
timer = 0
lives = random.randint(2, 8)
running = False
runningg_backe = False
Hits = False
font_name = pygame.font.match_font('arial')
# Задаем цвета,
WHITE = (255, 255, 255)
BLACK = (0, 0, 0)
RED = (255, 0, 0)
GREEN = (0, 255, 0)
BLUE = (0, 0, 255)

# условия победы
# win_time = random.randrange(30,60,2)# нормальная игра
win_time = 5  # для проверки


# Функция создания надписей
def draw_text(surf, text, size, x, y):
    font = pygame.font.Font(font_name, size)
    text_surface = font.render(text, True, WHITE)
    text_rect = text_surface.get_rect()
    text_rect.center = (x, y)
    surf.blit(text_surface, text_rect)


# объявляем классы
class Smoke_1(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.ray = -1
        self.frame = -1
        self.image = smoke_frames[self.frame]
        self.rect = self.image.get_rect()

    def update(self):
        if runningg_backe == False:
            if self.ray % (FPS // 6) == 0:
                self.frame += 1
                self.image = smoke_frames[self.frame]
            if self.ray == -1:
                self.rect = self.image.get_rect()
                self.rect.center = (360, 150)
            self.ray += 1
            if self.frame == 2:
                self.frame = - 1
        else:
            self.ray = -1


class Thief(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = thief_img
        self.image.set_colorkey(WHITE)
        self.rect = self.image.get_rect()
        self.rect.center = (340, HEIGHT // 2)

    def update(self):
        self.rect.x -= 4
        if self.rect.x <= 240:
            self.kill()


class Thief_car(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = thief_car_img
        self.image.set_colorkey(WHITE)
        self.rect = self.image.get_rect()
        self.rect.center = (260, 400)
        self.speedy = 0

    def update(self):
        if not thief.alive():
            self.rect.y -= 4
        if self.rect.bottom <= 0:
            self.speedy += 1
            self.kill()


class Thief_car2(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = thief_car_img
        self.image.set_colorkey(WHITE)
        self.rect = self.image.get_rect()
        self.rect.center = (250, 50)
        self.speedy = 0

    def update(self):
        if runningg_backe == True and lives <= 0 and self.speedy == 0:
            self.rect.y += 4
        if self.rect.bottom >= 550:
            self.speedy += 1


class Explosion(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.frame = 0
        self.image = explosion_anim[self.frame]
        self.rect = self.image.get_rect()
        self.last_update = pygame.time.get_ticks()
        self.frame_rate = FPS

    def update(self):
        now = pygame.time.get_ticks()
        if now - self.last_update > self.frame_rate:
            self.last_update = now
            self.frame += 1
            if int(self.frame) == len(explosion_anim):
                self.kill()
            else:
                center = self.rect.center
                self.image = explosion_anim[self.frame]
                self.rect = self.image.get_rect()
                self.rect.center = center


class Tire(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = tire_img
        self.image.set_colorkey(BLACK)
        self.image = pygame.transform.scale(tire_img, (8, 20))
        self.rect = self.image.get_rect()

    def update(self):
        self.rect.y += 7
        if self.rect.top > HEIGHT:
            self.rect.bottom = 0


class Bullet(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = bullet_img
        self.image.set_colorkey(WHITE)
        self.image = pygame.transform.scale(bullet_img, (2, 5))
        self.rect = self.image.get_rect()
        self.rect.center = (car.rect.x + 37, car.rect.y - 10)
        self.speedy = -10

    def update(self):
        self.rect.y += self.speedy
        # убить, если он заходит за верхнюю часть экрана
        if self.rect.bottom < 0:
            self.kill()


class Car(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.ray1 = -1
        self.ray = -1
        self.ray2 = -1
        self.ray3 = -1
        self.ray4 = -1
        self.ray5 = -1
        self.turn = False
        self.frame = 0
        self.frame1 = 0
        self.radius = 40
        self.image = cars_frame[self.frame]
        self.rect = self.image.get_rect()

    def shoot(self):
        bullet = Bullet()
        all_sprites.add(bullet)
        bullets.add(bullet)
        shoot_sound.set_volume(0.5)
        shoot_sound.play()

    def update(self):
        if runningg_backe == False:
            if self.turn == False:
                if self.ray % (FPS // 4) == 0:
                    self.frame += 1
                    self.image = cars_frame[self.frame]
                if self.ray == -1:
                    self.rect = self.image.get_rect()
                    self.rect.center = (250, 745)
                self.ray += 1
                if self.frame == 1:
                    self.frame = -1

        if runningg_backe == True:
            if self.ray2 % (FPS * 0.25) == 0:
                self.frame += 1
                self.image = policeman[self.frame]
            self.ray2 += 1
            if self.frame == 1:
                self.frame = -1
        if runningg_backe == True and self.ray2 == 0:
            self.rect = self.image.get_rect()
            self.rect.center = (250, 745)

    def turn_right(self):
        if runningg_backe == False:
            if self.frame1 == 7:
                self.turn = False
                self.frame1 = -1
            if self.turn == True:
                if self.ray1 % int((FPS)) == 0:
                    self.frame1 += 1
                    print(self.frame1)
                    self.image = car_right[6]
                    self.rect.x += 50

                self.ray1 += 1

    def turn_left(self):
        if runningg_backe == False:
            if self.frame1 == 7:
                self.turn = False
                self.frame1 = -1
            if self.turn == True:
                if self.ray3 % int((FPS)) == 0:
                    self.frame1 += 1
                    print(self.frame1)
                    self.image = car_left[6]
                    self.rect.x -= 50
                self.ray3 += 1

    def man_right(self):
        if runningg_backe == True:
            if self.frame1 == 7:
                self.turn = False
                self.frame1 = -1
            if self.turn == True:
                if self.ray4 % int((FPS)) == 0:
                    self.frame1 += 1
                    print(self.frame1)
                    self.image = policeman_right[6]
                    self.rect.x += 50
                self.ray4 += 1

    def man_left(self):
        if runningg_backe == True:
            if self.frame1 == 7:
                self.turn = False
                self.frame1 = -1
            if self.turn == True:
                if self.ray5 % int((FPS)) == 0:
                    self.frame1 += 1
                    print(self.frame1)
                    self.image = policeman_left[6]
                    self.rect.x -= 50
                self.ray5 += 1


class rocket(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = rocket_img
        self.speedy = 0
        self.image.set_colorkey(WHITE)
        self.rect = self.image.get_rect()
        self.rect.center = (50, 60)
        self.radius = 5

    def update(self):
        self.rect.y += 15
        if self.rect.top > HEIGHT:
            self.kill()


class rocket2(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = rocket_img
        self.speedy = 0
        self.image.set_colorkey(WHITE)
        self.rect = self.image.get_rect()
        self.rect.center = (450, 60)
        self.radius = 5

    def update(self):
        self.rect.y += 15
        if self.rect.top > HEIGHT:
            self.kill()


class Brick1(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = random.choice(cars_img)
        self.image.set_colorkey(BLACK)
        self.rect = self.image.get_rect()
        self.speedy = random.randrange(7, 15, 2)
        self.radius = 40

    def update(self):
        self.rect.y += self.speedy
        if self.rect.top > HEIGHT:
            self.rect.bottom = 0
            self.speedy = random.randrange(7, 15, 2)
            self.image = random.choice(cars_img)
            self.image.set_colorkey(BLACK)


# Создаем игру и окно
pygame.init()
pygame.mixer.init()
screen = pygame.display.set_mode((WIDTH, HEIGHT))
pygame.display.set_caption("My Game")
clock = pygame.time.Clock()
# объяляем группы
all_sprites = pygame.sprite.Group()
alll_sprites = pygame.sprite.Group()
bullets = pygame.sprite.Group()
gh = pygame.sprite.Group()
start_mob = pygame.sprite.Group()
player_spr = pygame.sprite.Group()
# Объявляем пути
f = "C:\\Users\\Tolmaks\\Images\\"
file = "C:\\Users\\Tolmaks\\Images\\police_right\\Image"
file1 = "C:\\Users\\Tolmaks\\Images\\police\\Image"
fil = "C:\\Users\\Tolmaks\\sounds\\"
img_folder = os.path.dirname(f)
snd_dir = os.path.dirname(fil)
#Добавляем картинки

#Для класса smoke1
smoke_frames = []
for i in range(3):
    filename1 = 'Дымок{}.png'.format(i)
    img = pygame.image.load(
        os.path.join(os.path.dirname(f), filename1)).convert()
    img.set_colorkey(WHITE)
    smoke_frames.append(img)
#Для поворота класса car вправо при победе
policeman_right = []
for i in range(8):
    filename1 = 'car_police_police_right_{}.png'.format(i)
    img = pygame.image.load(
        os.path.join(os.path.dirname("C:\\Users\\Tolmaks\\Images\\police_police_right\\Image"), filename1)).convert()
    img.set_colorkey(BLACK)
    policeman_right.append(img)
#Для поворота класса car влево при победе
policeman_left = []
for i in range(8):
    filename1 = 'car_police_police_left_{}.png'.format(i)
    img = pygame.image.load(
        os.path.join(os.path.dirname("C:\\Users\\Tolmaks\\Images\\police_police_left\\Image"), filename1)).convert()
    img.set_colorkey(BLACK)
    policeman_left.append(img)
#Для поворота класса car влево
car_left = []
for i in range(8):
    filename1 = 'car_police_left_{}.png'.format(i)
    img = pygame.image.load(
        os.path.join(os.path.dirname("C:\\Users\\Tolmaks\\Images\\police_left\\Image"), filename1)).convert()
    img.set_colorkey(BLACK)
    car_left.append(img)
#Для поворота класса car вправо
car_right = []
for i in range(8):
    filename1 = 'car_police_right_{}.png'.format(i)
    img = pygame.image.load(os.path.join(os.path.dirname(file), filename1)).convert()
    img.set_colorkey(BLACK)
    car_right.append(img)
#Для класса car мигалка
cars_frame = []
for i in range(2):
    filename2 = 'car_police{}.png'.format(i)
    img = pygame.image.load(os.path.join(os.path.dirname(file1), filename2)).convert()
    img.set_colorkey(BLACK)
    cars_frame.append(img)
#Для класса car мигалка при победе
policeman = []
for i in range(2):
    filename2 = 'car_police_police{}.png'.format(i)
    img = pygame.image.load(
        os.path.join(os.path.dirname("C:\\Users\\Tolmaks\\Images\\police_police\\Image"), filename2)).convert()
    img.set_colorkey(BLACK)
    policeman.append(img)
#Для класса Explosion
explosion_anim = []
for i in range(9):
    filename = 'regularExplosion0{}.png'.format(i)
    img = pygame.image.load(os.path.join(img_folder, filename)).convert()
    img.set_colorkey(BLACK)
    img_lg = pygame.transform.scale(img, (75, 75))
    explosion_anim.append(img_lg)
#Задаем звук
shoot_sound = pygame.mixer.Sound(os.path.join(snd_dir, 'Pew.wav'))#Звук для выстрелов
bum_sound = pygame.mixer.Sound(os.path.join(snd_dir, 'Buuum.wav'))#Звук для взрывов
music = pygame.mixer.Sound(os.path.join(snd_dir, 'Music_for_police_chase.wav'))#Музыка
#Скины машинок
cars_img=[]
cars = ['car1_blue.png', 'car1_green.png', 'car1_orange.png', 'car1_purple.png', 'car1_red.png', 'car1_yellow.png',
        'car2_blue.png', 'car2_green.png', 'car2_orange.png',
        'car2_purple.png', 'car2_red.png', 'car2_yellow.png', 'car3_blue.png', 'car3_green.png', 'car3_orange.png',
        'car3_purple.png', 'car3_red.png', 'car3_yellow.png',
        'car4_blue.png', 'car4_green.png', 'car4_orange.png', 'car4_purple.png', 'car4_red.png', 'car4_yellow.png',
        'car5_blue.png', 'car5_green.png', 'car5_orange.png',
        'car5_purple.png', 'car5_red.png', 'car5_yellow.png', 'car6_blue.png', 'car6_green.png', 'car6_orange.png',
        'car6_purple.png', 'car6_red.png', 'car6_yellow.png',
        'car7_green.png', 'car7_orange.png', 'car7_orange.png', 'car7_purple.png', 'car7_red.png', 'car7_yellow.png']
for img in cars:
    cars_img.append(pygame.image.load(os.path.join(img_folder, img)).convert())
#Загружаем фоны
background = pygame.image.load(os.path.join(img_folder, 'bg.png')).convert()
background_rect = background.get_rect()
background_start = pygame.image.load(os.path.join(img_folder, 'startbg1.png')).convert()
background_start_rect = background.get_rect()
background_0 = pygame.image.load(os.path.join(img_folder, 'заставка_bg.png')).convert()
background_0_rect = background.get_rect()
bullet_img = pygame.image.load(os.path.join(img_folder, 'bullet.png')).convert()#картинка пули
thief_img = pygame.image.load(os.path.join(img_folder, 'вор.png')).convert()#Картинка вора
thief_car_img = pygame.image.load(os.path.join(img_folder, 'car_вора.png')).convert()#Картинка машинки вора
tire_img = pygame.image.load(os.path.join(img_folder, 'TireWhite.png')).convert()#Картинка разметки
rocket_img = pygame.image.load(os.path.join(img_folder, 'rocket.png')).convert()#Картинка Рокеты
#Добавление всех классов
for i in range(0, 42):
    tire = Tire()
    tire.rect.center = (x_, y_)
    gh.add(tire)
    all_sprites.add(tire)
    y_ += 40
    if i == 20:
        x_ += 100
        y_ = 10
car = Car()
Rocket = rocket()
Rocket2 = rocket2()
thief = Thief()
smoke2 = Smoke_1()
thief_car = Thief_car()
thief_car2 = Thief_car2()
start_mob.add(thief)
start_mob.add(thief_car)
alll_sprites.add(thief_car2)
alll_sprites.add(car)
all_sprites.add(car)
start_mob.add(smoke2)
gh.add(car)
x_ = 150
for i in range(0, 3):
    mob = Brick1()
    mob.rect.center = (x_, 0)
    all_sprites.add(mob)
    player_spr.add(mob)
    x_ += 100
all_sprites.add(car)
time1 = 0

# Цикл игры
running = True
win = False
running_all = True
music.play(loops=-1)
while running_all:
    music.set_volume(0.4)
    clock.tick(FPS)
    for event in pygame.event.get():
        # check for closing window
        if event.type == pygame.QUIT:
            running_all = False
        elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_SPACE:
                running_all = False
    # Рендеринг
    screen.blit(background_start, background_start_rect)
    draw_text(screen, 'Click on space to start ', 34, WIDTH // 2, HEIGHT // 2 + 150)
    pygame.display.flip()
tim = 0
tim2 = 0
running_all = True

while running_all:
    clock.tick(FPS)
    for event in pygame.event.get():
        # check for closing window
        if event.type == pygame.QUIT:
            running_all = False
        elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_SPACE:
                running_all = False

    # Рендеринг
    if thief_car.speedy == 1:
        running_all = False
    screen.blit(background_0, background_0_rect)
    draw_text(screen, 'Click on space to miss ', 20, 150, 660)
    start_mob.update()
    start_mob.draw(screen)
    pygame.display.flip()

while running:
    music.set_volume(0.6)
    # Держим цикл на правильной скорости
    clock.tick(FPS)
    # Ввод процесса (события)
    for event in pygame.event.get():
        # check for closing window
        if event.type == pygame.QUIT:
            running = False
        elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_RIGHT and car.rect.x + 100 < 500:
                ime = 120
                car.turn = True
                while ime != 0:
                    ime -= 1
                    car.turn_right()
                car.turn = False
                car.frame1 = -1
            if event.key == pygame.K_LEFT and car.rect.x - 100 > -50:
                ime = 120
                car.turn = True
                while ime != 0:
                    ime -= 1
                    car.turn_left()
                car.turn = False
                car.frame1 = -1
    # Обновление
    all_sprites.update()
    # Проверка на выполнение квеста
    if time2 == win_time and car.alive():
        win = True
        running = False
    # Проверка, не ударил ли моб игрока
    hits = pygame.sprite.spritecollide(car, player_spr, True, pygame.sprite.collide_circle)
    if hits:
        bum_sound.set_volume(0.5)
        bum_sound.play()
        expl = Explosion()
        death_explosion = Explosion()
        expl.rect.center = (int(car.rect.x) + 20, 700)
        all_sprites.add(expl)
        Hits = True
        mob = Brick1()
        player_spr.add(mob)
        death_explosion.rect.center = car.rect.center
        all_sprites.add(death_explosion)
        car.kill()
    if Hits:
        tim += 1
        if tim % (38) == 0:
            running = False

    # Рендеринг
    screen.blit(background, background_rect)
    time1 += 1
    if time1 % FPS == 0:
        time2 += 1
    draw_text(screen, str(time2) + ' seconds', 18, 50, 10)
    draw_text(screen, str(win_time - time2) + ' seconds left', 18, 450, 10)
    if car.rect.x + 100 > 500 or car.rect.x - 100 < -50:
        timer += 1
        if timer % FPS == 0:
            active_lov += 1
        if active_lov >= 1 and Rocket.rect.y < HEIGHT:
            player_spr.add(Rocket)
            player_spr.add(Rocket2)
            all_sprites.add(Rocket)
            all_sprites.add(Rocket2)
    else:
        timer = 0
        active_lov = 0
    all_sprites.draw(screen)
    # После отрисовки всего, переворачиваем экран
    pygame.display.flip()

wine = False
time1 = 0
time2 = 0
music.set_volume(0.4)
if win == True:
    runningg_backe = True
    while runningg_backe:
        clock.tick(FPS)
        for event in pygame.event.get():
            # check for closing window
            if event.type == pygame.QUIT:
                runningg_backe = False
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_SPACE and wine == False:
                    car.shoot()
                elif event.key == pygame.K_SPACE and wine and time22 >= 2:
                    runningg_backe = False
                elif event.key == pygame.K_RIGHT and car.rect.x + 100 < 400 and wine == False:
                    ime = 120
                    car.turn = True
                    while ime != 0:
                        ime -= 1
                        car.man_right()
                    car.turn = False
                    car.frame1 = -1
                elif event.key == pygame.K_LEFT and car.rect.x - 100 > 50 and wine == False:
                    ime = 120
                    car.turn = True
                    while ime != 0:
                        ime -= 1
                        car.man_left()
                    car.turn = False
                    car.frame1 = -1
        hits2 = pygame.sprite.spritecollide(thief_car2, bullets, True)
        if hits2:
            lives -= 1
        # Рендеринг
        screen.blit(background, background_rect)
        alll_sprites.update()
        bullets.update()
        if time22 < 2:
            gh.update()
        alll_sprites.draw(screen)
        gh.draw(screen)
        bullets.draw(screen)
        time1 += 1
        if time1 % FPS == 0:
            time2 += 1
            #Передвижение машинки вора
            side = random.randint(1, 2)
            if side == 1 and thief_car2.rect.x + 100 < 500:
                thief_car2.rect.x += 100
            if side == 2 and thief_car2.rect.x - 100 > -50:
                thief_car2.rect.x -= 100
            if side == 1 and thief_car2.rect.x > 400:
                thief_car2.rect.x -= 100
            if side == 2 and thief_car2.rect.x < 100 and time22 < 2:
                thief_car2.rect.x += 100
        if lives <= 0:
            wine = True
        if wine:
            time11 += 1
            if time11 % FPS == 0:
                time22 += 1
            if time22 >= 2:
                thief_car2.rect.x = 100
                car.rect.x = 100
                draw_text(screen, 'You win!!!  ', 34, WIDTH // 2, 350)
                draw_text(screen, ' I congratulate you on the passage! ', 34, WIDTH // 2, 400)
                draw_text(screen, '  Thank you! ', 34, WIDTH // 2, 450)
                draw_text(screen, 'Click on space  ', 24, WIDTH // 2, 600)
        pygame.display.flip()
running = True
if win == False:
    while running:
        clock.tick(FPS)
        for event in pygame.event.get():
            # check for closing window
            if event.type == pygame.QUIT:
                running = False
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_SPACE:
                    running = False
        # Рендеринг
        screen.fill(BLACK)
        draw_text(screen, 'You lose ', 34, WIDTH // 2, HEIGHT // 2)
        draw_text(screen, 'Click on space bar  ', 24, WIDTH // 2, 600)
        pygame.display.flip()

pygame.quit()